using System;

namespace Sasa.QualityTools.DrFx.Tests.Violation.CSharp.Microsoft.Usage
{
    public class Rule1816A : IDisposable
    {
        protected virtual void Dispose(bool disposing)
        {
            if (disposing)
            {
            }
        }

        // このメソッドは CA1816:NotCalled に違反しています。
        public void Dispose()
        {
            Dispose(true);
        }
    }

    public static class Rule1816B
    {
        // このメソッドは CA1816:NotPassedThis に違反しています。
        // このメソッドは CA1816:OutsideDispose に違反しています。
        public static string CreateMessage()
        {
            GC.SuppressFinalize(0);
            return "hello";
        }
    }
}
